function [X, W, out] = INDS(S, r, conv, start, method)
% program for indscal DIRECT  on similarity matrices min sum(k) SS( S(k)-X W(k) X' )
%
% input: S=(S(1)...S(K)) matrices;
%	 r: dimensionality of solution
%	 conv: convergence criterion
%
% work array: C=X'X;
%
%	solution: W (rows containing W(k)'s) and X (n x r)
%
%	start = 0 default; start=1: current
%	r = number of dimensions
%	method = 2 uses Kronecker-PCA procedure 
% 	conv= convergence crit.
% 	start: 0 = default; 1 = random; 2 = current values 
% Written by Henk A.L. Kiers, University of Groningen
 
[n,mn]=size(S);
m=mn/n;


disp('r');disp(r);
disp('conv');disp(conv);
disp('start');disp(start);

% conv=input(' convergence crit.: ');
% start=input(' 0 = default; 1 = random; 2 = current values ');
if start~=1,nanal=1;end;
if start==1
  nanal=input(' How many starts do you want to use ');
end;

dysm(1:nanal)=zeros(1,nanal);Xsol=[];Wsol=[];
for ana=1:nanal

% initialize X
 if start==0
  U=zeros(n,n);
  for k=1:m
   U=U+S(:,(k-1)*n+1:k*n); 
  end;
  [p,d,q]=svd(U,0);
  X=p(:,1:r);
  W=ones(m,r);
 end;
 if start==1
  rand('seed',ana)
  X=orth(rand(n,r)-.5);
  W=rand(m,r);
end;
%method=1
% method=input(' 1 = ordinary; 2 = via Kronecker PCA ');
% if method==2
%   beta=input(' acceleration factor: ');
% end;
beta=1;
f=1000*ssq(S)^2;
fold=f+2*conv*f;
iter=0;
obj(iter+1) = f;

if method==1
 while fold-f>conv*f | iter<3
  fold=f;
  iter=iter+1;

% update X

  B=zeros(r,r);
  BB=zeros(n,r);
  for k=1:m B=B+diag(W(k,:))*X'*X*diag(W(k,:)); end;
  mm=0;  
  for k=1:m
    BB=BB+S(:,(k-1)*n+1:k*n)*X*diag(W(k,:));
  end;
  X=BB/B;

% update W(k)'s

  mm=0;
  for k=1:m 
    W(k,:)=(diag(X'*S(:,(k-1)*n+1:k*n)*X))'/((X'*X).*(X'*X));
  end;    
  ff=0;
  for k=1:m
    ff=ff+ssq(S(:,(k-1)*n+1:k*n)-X*diag(W(k,:))*X');
  end;
  disp(iter);disp(ff);
  f=ff;
  obj(iter+1) = f;
  
  if f>fold
   disp(' Restarted because of dysmonotony ');dysm(ana)=1;
   % random restart; 
   X=orth(rand(n,r)-.5);W=rand(m,r); 
   f=0;
   for k=1:m
     f=f+ssq(S(:,(k-1)*n+1:k*n)-X*diag(W(k,:))*X');
   end;
   fold=f+2*conv*f;
  end;
 end;
 out.obj = obj;
end;    

if method==2
 while fold-f>conv*f | iter<3
  fold=f;
  iter=iter+1

% compute alfa:

  alf=max(eiv(W'*W))/beta;

% update X

  B=Kron(X,X);
  for k=1:m
    Sk=S(:,(k-1)*n+1:k*n);
    Rk=diag(W(k,:));
    ARkA=X*Rk*X';
    B=B+Sk(:)*Rk(:)'/alf-ARkA(:)*Rk(:)'/alf;
  end;
  X=KronPCA(B,n,r);

  ff=0;
  for k=1:m
    ff=ff+ssq(S(:,(k-1)*n+1:k*n)-X*diag(W(k,:))*X');
  end;
  disp(' after updating X ');ff

% update W(k)'s

  for k=1:m 
    W(k,:)=(diag(X'*S(:,(k-1)*n+1:k*n)*X))'/((X'*X).*(X'*X));
  end;    
  ff=0;
  for k=1:m
    ff=ff+ssq(S(:,(k-1)*n+1:k*n)-X*diag(W(k,:))*X');
  end;
  f=ff
 end;
  
end;    
 func(ana)=f;
 Xsol(:,ana)=X(:);
 Wsol(:,ana)=W(:);
end;
disp(' Minimal function value is ');
[mm,mi]=min(func)
X(:)=Xsol(:,mi);
W(:)=Wsol(:,mi);
D=diag(diag(X'*X));
X=n^.5*X/D^.5;
ss=sum(X);
refl=ss<0;
X(:,refl)=-X(:,refl);
W=W*D/n;
disp(' X (standardized) and W contain solution; func contais function values');
disp(' dysm shows when dysmonotonies were encountered and alg. was restarted');  

end