function [ S ] = representationBinVar( x )
% representation matrix of a binary variable
% input:
%      x: a vector of 0 or 1.
% output:
%      S: representation matrix

% create dummy coding of binary data
G = dummyvar(x+1);

% column centering matrix
m = length(x);
J = (eye(m) - (1/m)*ones(m,1)*ones(m,1)');

% weighting matrix
empFreq = mean(x);
diagD   = [1-empFreq, empFreq];
inverD  = diag((1./diagD));

% representation matrix 
S = J*G*inverD*G'*J;

end

